//
//  SBConfigureSingletonView.m
//  SixBookmarks
//
//  Created by ss on 11. 6. 17..
//  Copyright 2011 OpenTheGate. All rights reserved.
//

#import "SBConfigureSingletonView.h"
#import "MyClasses.h"


@implementation SBConfigureSingletonView

@synthesize bookmark;
@synthesize textName;
@synthesize textUrl;


-(void)setOrdinal:(int)theOrdinal
{
    // try and load it...
	SBBookmark *theBookmark = nil;
	NSError *err = [SBBookmark getByOrdinal:theOrdinal bookmark:&theBookmark];
	if(err != nil)
		[SBMessageBox showError:err];
	else
	{
		// create...
		if(theBookmark == nil)
		{
			theBookmark = [[[SBBookmark alloc] init] autorelease];
			
			// set the ordinal (so that we save into the right place)...
			theBookmark.ordinal = theOrdinal;
		}
		
		// set...
		self.bookmark = theBookmark;
	}
	
	// update...
	self.refreshView;
}


-(void)refreshView
{	
	// set...
	if(self.bookmark != nil)
	{
		[self.textName setText:[self.bookmark name]];
		[self.textUrl setText:[self.bookmark url]];
	}
	else 
	{
		[self.textName setText:nil];
		[self.textUrl setText:nil];
	}
}



-(IBAction)handleCancel:(int)sender
{
    [self.owner openConfiguration];
}


-(IBAction)handleSave:(int)sender

{
    // get the values...
	NSString *name = self.textName.text;
	NSString *url = self.textUrl.text;
	
	// can we?
	SBErrorBucket *errors = [[SBErrorBucket alloc] init];
	if(name == nil || [name length] == 0)
		[errors addError:@"Name is required."];
	if(url == nil || [url length] == 0)
		[errors addError:@"URL is required."];
	
	// ok...
	if(!([errors hasErrors]))
	{
		// save the regular bits...
		[self.bookmark setName:name];
		[self.bookmark setUrl:url];
		
		// set the flags...
		[self.bookmark setLocalModified:TRUE];
		[self.bookmark setLocalDeleted:FALSE];
		
		// save...
		[self.bookmark saveChanges];
		
		// ok...
		[self.owner openConfiguration];
	}
	else
		[SBMessageBox show:[errors errorsAsString]];
	
	// release...
	[errors release];
}


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)dealloc
{
    [bookmark release];
    [textName release];
    [textUrl release];
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
