//
//  SBEntity.h
//  SixBookmarks
//
//  Created by ss on 11. 5. 9..
//  Copyright 2011 OpenTheGate. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "SBEntitySetReason.h"
#import "SBEntityFieldFlags.h"
#import "SBEntityField.h"




@interface SBEntity : NSObject {
    
    SBEntity *entityType;
    NSMutableArray *values;
    NSMutableArray *flags;
    
}


@property (nonatomic, retain) SBEntity *entityType;
@property (nonatomic, retain) NSMutableArray *values;
@property (nonatomic, retain) NSMutableArray *flags;


-(void)setValueByName:(NSString *)name value:(NSObject *)theValue reason:(SBEntitySetReason)theReason;
-(void)setValue:(SBEntityField *)field value:(NSObject *)theValue reason:(SBEntitySetReason)theReason;
-(void)setFieldFlags:(SBEntityField *)field flags:(SBEntityFieldFlags)theFlags setOn:(BOOL)doSetOn;


-(BOOL)isFieldLoaded:(SBEntityField *)field;
-(BOOL)isFieldModified:(SBEntityField *)field;
-(BOOL)getFieldFlags:(SBEntityField *)field flags:(SBEntityFieldFlags)theFlags;

-(int)getInt32Value:(SBEntityField *)field;
-(int)getInt32ValueByName:(NSString *)name;
-(BOOL)getBooleanValue:(SBEntityField *)field;
-(BOOL)getBooleanValueByName:(NSString *)name;
-(NSString *)getStringValue:(SBEntityField *)field;
-(NSString *)getStringValueByName:(NSString *)name;

-(BOOL)isNew;
-(BOOL)isModified;
-(BOOL)isDeleted;


-(void)populateFromValues:(NSMutableDictionary *)theValues;

-(void)saveChanges;


@end
