//
//  SBHttpHelper.m
//  SixBookmarks
//
//  Created by ss on 11. 5. 2..
//  Copyright 2011 OpenTheGate. All rights reserved.
//

#import "SBHttpHelper.h"
#import "SBDownloadBucket.h"


@implementation SBHttpHelper

+(NSString *)buildQueryString:(NSDictionary *)theArgs
{
    NSMutableString *builder = [[NSMutableString alloc] init];
    bool first = TRUE;
    for(NSString *name in theArgs)
    {
        if(first)
            first = FALSE;
        else
            [builder appendString:@"&"];
        
        [builder appendString:name];
        [builder appendString:@"="];
        [builder appendString:[theArgs objectForKey:name]];
    }
    
    //return...
    return builder;
}

+(NSString *)buildUrl:(NSString *)url args:(NSDictionary *)theArgs
{
    //trim the query string...
    NSRange range = [url rangeOfString:@"?"];
    if(range.length > 0)
        url = [url substringToIndex:range.location];
    
    //build...
    url = [NSString stringWithFormat:@"%@?%@", url, [self buildQueryString:theArgs]];
    
    //return...
    return url;
}


+(void)download:(NSString *)url settings:(SBDownloadSettings *)theSettings callback:(SBDownloadCallback *)theCallback opCode:(int)theOpCode
{
    //create a bucket...
    SBDownloadBucket *bucket = [[SBDownloadBucket alloc] initWithCallback:theCallback opCode:theOpCode];
    
    //run...
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:url] cachePolicy:NSURLRequestUseProtocolCachePolicy  timeoutInterval:60.0];
    
    //add the headers...
    for(NSString *name in theSettings.extraHeaders)
    {
        NSString *value = [theSettings.extraHeaders objectForKey:name];
        [request addValue:value forHTTPHeaderField:name];
    }
    
    //create the connection with the request and start loading the data...
    [NSURLConnection connectionWithRequest:request delegate:bucket];
}


@end
