//
//  SBLogonView.m
//  SixBookmarks
//
//  Created by ss on 11. 5. 2..
//  Copyright 2011 OpenTheGate. All rights reserved.
//

#import "SBLogonView.h"
#import "MyClasses.h"

#import "SBUsersService.h"
#import "SBNavigatorView.h"
#import "SBViewController.h"
#import "SBSync.h"

#import "SBRuntime.h"

@implementation SBLogonView

@synthesize textUsername;
@synthesize textPassword;
@synthesize checkRememberMe;
@synthesize buttonLogon;
@synthesize loggingOnUser;

-(IBAction)handleLogonClick:(id)sender
{
    // get the values...
    NSString *username = self.textUsername.text;
    NSString *password = self.textPassword.text;
    
    // valdiate...
    SBErrorBucket *bucket = [[SBErrorBucket alloc] init];
    if(username == nil || username.length == 0)
        [bucket addError:@"Username is required"];
    if(password == nil || password.length == 0)
        [bucket addError:@"Password is required"];
    
    // now what?
    if(!(bucket.hasErrors))
    {
        //store for future use...
        self.loggingOnUser = username;
        
        
        // we'll do the logon operation in here...
        SBUsersService *users = [[SBUsersService alloc] init];
        [users logon:username password:password callback:(SBLogonCallback *)self];
        [users release];
    }
    else
        [SBMessageBox show:bucket.errorsAsString];
    
    // cleanup...
    [bucket release];
}



-(void)logonOk
{
    //[SBMessageBox show:@"Logon OK."];
    //[self.owner openNavigator];
    
    
    //store the username...
    [[SBRuntime current] setUsername:self.loggingOnUser];
    self.loggingOnUser = nil;
    
    
    //do a sync...
    SBSync *sync = [[[SBSync alloc] init] autorelease];
    [sync doSync:(SBSyncCallback *)self];
}



-(void)logonFailed:(NSError *)theError
{
    [SBMessageBox showError:theError];
}


-(void)syncOk
{
    [self.owner openNavigator];
}


-(void)syncFailed:(NSError *)error
{
    [SBMessageBox showError:error];
}


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}


- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

- (void)dealloc
{
    [textUsername release];
    [textPassword release];
    [checkRememberMe release];
    [buttonLogon release];
    [loggingOnUser release];
    
    [super dealloc];
}

@end
