//
//  SBNavigatorView.m
//  SixBookmarks
//
//  Created by ss on 11. 5. 9..
//  Copyright 2011 OpenTheGate. All rights reserved.
//

#import "SBNavigatorView.h"
#import "MyClasses.h"

#import "SBBookmark.h"
#import "SBRuntime.h"


@implementation SBNavigatorView


@synthesize buttonNavigate1;
@synthesize buttonNavigate2;
@synthesize buttonNavigate3;
@synthesize buttonNavigate4;
@synthesize buttonNavigate5;
@synthesize buttonNavigate6;
@synthesize bookmarks;


-(IBAction)handleLogoff:(id)sender
{
	[SBMessageBox show:@"TBD"];
}

-(IBAction)handleConfigure:(id)sender
{
	[self.owner openConfiguration];
}

-(IBAction)handleNavigate:(id)sender
{
    if (sender == self.buttonNavigate1)
		[self doNavigate:0];
	else if (sender == self.buttonNavigate2)
		[self doNavigate:1];
	else if (sender == self.buttonNavigate3)
		[self doNavigate:2];
	else if (sender == self.buttonNavigate4)
		[self doNavigate:3];
	else if (sender == self.buttonNavigate5)
		[self doNavigate:4];
	else if (sender == self.buttonNavigate6)
		[self doNavigate:5];
}


-(SBBookmark *)getBookmarkByOrdinal:(int)ordinal
{
	for(SBBookmark *bookmark in self.bookmarks)
	{
		if([bookmark ordinal] == ordinal)
			return bookmark;
	}
	
	// nope...
	return nil;
}

-(void)doNavigate:(int)ordinal
{
	SBBookmark *bookmark = [self getBookmarkByOrdinal:ordinal];
	if(bookmark != nil)
		[[SBRuntime current] showUrl:bookmark.url];
	else
		[self handleConfigure:self];
}



-(IBAction)handleAbout:(id)sender
{
	[SBMessageBox show:@"TBD"];
}


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}


- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


-(void)refreshView
{
    /*
    //create some fake bookmarks...
    NSMutableArray *theBookmarks = [NSMutableArray array];
    
    // first one...
    SBBookmark *bookmark = [[SBBookmark alloc] init];
    bookmark.ordinal = 0;
    bookmark.name = @".NET 247";
    bookmark.url = @"http://www.dotnet247.com/";
    [theBookmarks addObject:bookmark];
    [bookmark release];
    
    // second one...
    bookmark = [[SBBookmark alloc] init];
    bookmark.ordinal = 1;
    bookmark.name = @"Apress";
    bookmark.url = @"http://www.apress.com/";
    [theBookmarks addObject:bookmark];
    [bookmark release];
     */
    
    //get them...
    NSMutableArray *theBookmarks = nil;
    NSError *err = [SBBookmark getBookmarksForDisplay:&theBookmarks];
    if (err != nil) {
        [SBMessageBox showError:err];
        return;
    }
    
    
    // show...
    [self showBookmarks:theBookmarks];
    
}


-(UIButton *)getButton:(int)ordinal
{
    if (ordinal == 0)
        return self.buttonNavigate1;
    else if (ordinal == 1)
        return self.buttonNavigate2;
    else if (ordinal == 2)
        return self.buttonNavigate3;
    else if (ordinal == 3)
        return self.buttonNavigate4;
    else if (ordinal == 4)
        return self.buttonNavigate5;
    else if (ordinal ==5)
        return buttonNavigate6;
    else
        return nil;
}


-(void)resetButton:(int)ordinal
{
    UIButton *button = [self getButton:ordinal];
    [button setTitle:@"..." forState:UIControlStateNormal];
}


-(void)setupButton:(SBBookmark *)bookmark
{
    //get...
    UIButton *button = [self getButton:[bookmark ordinal]];
    [button setTitle:[bookmark name] forState:UIControlStateNormal];
}


-(void)showBookmarks:(NSMutableArray *)theBookmarks
{
    //reset all buttons...
    for (int index = 0; index < 6; index++)
        [self resetButton:index];
    
    //show the buttons...
    for (SBBookmark *bookmark in theBookmarks)
        [self setupButton:bookmark];
    
    //store the bookmarks...
    self.bookmarks = theBookmarks;
}




- (void)dealloc
{
    [buttonNavigate1 release];
	[buttonNavigate2 release];
	[buttonNavigate3 release];
	[buttonNavigate4 release];
	[buttonNavigate5 release];
	[buttonNavigate6 release];
	[bookmarks release];
    [super dealloc];
}


@end
