//
//  SBServiceProxy.m
//  SixBookmarks
//
//  Created by ss on 11. 5. 2..
//  Copyright 2011 OpenTheGate. All rights reserved.
//

#import "SBServiceProxy.h"
#import "MyClasses.h"


static NSString *_token;

@implementation SBServiceProxy

@synthesize serviceName;


//YOU MUST CHANGE THIS IN ORDER TO USE THE SAMPLE...
const NSString *APIUSERNAME = @"username";
const NSString *APIPASSWORD = @"password";



-(id)initWithServiceName:(NSString *)theServiceName
{
    if(self == [super init])
    {
        self.serviceName = theServiceName;
    }
    
    //return...
    return self;
}


-(NSString *)resolvedServiceUrl
{
    return [NSString stringWithFormat:@"%@%@", @"http://services.multimobiledevelopment.com/", self.serviceName];
}



-(SBDownloadSettings *)getDownloadSettings
{
    SBDownloadSettings *settings = [[SBDownloadSettings alloc] init];
    
    //set...
    [settings addHeader:(NSString *)APIUSERNAME forName:@"x-amx-apiusername"];
    NSString *theToken = [SBServiceProxy token];
    if (theToken != nil && theToken.length > 0)
    {
        [settings addHeader:theToken forName:@"x-amx-token"];
    }
    
    //return...
    return settings;
}


+(NSString *)token
{
    return _token;
}


+(void)setToken:(NSString *)theToken
{
    [_token release];
    _token = [theToken retain];
}


+(BOOL)hasToken
{
    if (_token != nil && _token.length > 0)
        return TRUE;
    else
        return FALSE;
}


+(void)startSpinning
{
    //start spinning...
    [UIApplication sharedApplication].networkActivityIndicatorVisible = TRUE;
}


+(void)stopSpinning
{
    //stop spinngin...
    [UIApplication sharedApplication].networkActivityIndicatorVisible = FALSE;
}









-(void)dealloc
{
    [serviceName release];
    [super dealloc];
}


@end
