//
//  SBSync.h
//  SixBookmarks
//
//  Created by ss on 11. 5. 10..
//  Copyright 2011 OpenTheGate. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SBEntityXmlBucket.h"

@interface SBSyncCallback : NSObject
-(void)syncOk;
-(void)syncFailed:(NSError *)err;
@end

typedef enum
{
	SBSMGetLatest = 0,
    SBSMPushChanges = 1
    
} SBSyncMode;

@interface SBSync : NSObject {
    
    SBSyncCallback *callback;
	SBSyncMode mode;
    NSMutableArray *updates;
    NSMutableArray *deletes;
    NSMutableArray *workItems;
    int workItemIndex;
    
}

@property (nonatomic, retain) SBSyncCallback *callback;
@property (assign) SBSyncMode mode;
@property (nonatomic, retain) NSMutableArray *updates;
@property (nonatomic, retain) NSMutableArray *deletes;
@property (nonatomic, retain) NSMutableArray *workItems;
@property (assign) int workItemIndex;

-(void)doSync:(SBSyncCallback *)theCallback;
-(void)getLatest;

-(void)processServerItemsForGetAll:(SBEntityXmlBucket *)entities;
-(void)receiveServerItemsForPushChanges:(SBEntityXmlBucket *)entities;
-(void)processWorkItems;


-(void)sendChanges;

@end
