//
//  SixBookmarksAppDelegate.m
//  SixBookmarks
//
//  Created by ss on 11. 5. 2..
//  Copyright 2011 OpenTheGate. All rights reserved.
//

#import "SixBookmarksAppDelegate.h"
#import "MyClasses.h"
#import "SixBookmarksViewController.h"

#import "SBRuntime.h"
#import "SBViewController.h"
#import "SBNavigatorView.h"

#import "SBConfigureView.h"
#import "SBConfigureSingletonView.h"







@implementation SixBookmarksAppDelegate


@synthesize window;
//@synthesize viewController;

@synthesize controllers;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    //create ...
    //SBLogonView *logon = [[SBLogonView alloc] initWithNibName:@"SBLogonView" bundle:[NSBundle mainBundle]];
    //self.viewController = logon;
    //[logon release];
    
    
    
    // Override point for customization after application launch.
     
    //self.window.rootViewController = self.viewController;
    //[self.window makeKeyAndVisible];
    //return YES;
    
    
    //start the runtime...
    [SBRuntime start];
    
    //show the form...
    [self openLogon];
    return YES;
    
    
    
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
     */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    /*
     Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
     */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    /*
     Called when the application is about to terminate.
     Save data if appropriate.
     See also applicationDidEnterBackground:.
     */
}



-(id)init
{
    if (self == [super init])
        self.controllers = [NSMutableDictionary dictionary];
    
    //return...
    return self;
}



-(SBViewController *)currentController
{
    //find the current view - 
    for (NSString *key in self.controllers) {
        SBViewController *controller = [self.controllers objectForKey:key];
        if (controller.view != nil && controller.view.superview != nil)
            return controller;
    }
    
    //return...
    return nil;
}


-(SBViewController *)getController:(Class)theClass
{
    return (SBViewController *)[self.controllers objectForKey:[theClass description]];
}


-(void)showView:(SBViewController *)theController
{
    //Is this first?
    SBViewController *current = self.currentController;
    
    //set the owner to be us...
    [theController setOwner:self];
    
    //do we have it in the collection?
    NSString *key = [theController.class description];
    if ([self.controllers objectForKey:key] == nil)
        [self.controllers setValue:theController forKey:key];
    
    //add...
    [window addSubview:theController.view];
    
    //do we have a view?
    if (current == nil)
        [window makeKeyAndVisible];
    else
    {
        //remove...
        [current.view removeFromSuperview];
    }
    
    //update...
    [theController refreshView];
}


-(void)openLogon
{
    //find the preexisting view...
    SBViewController *view = [self getController:[SBLogonView class]];
    if (view == nil)
        view = [[SBLogonView alloc] initWithNibName:@"SBLogonView" bundle:[NSBundle mainBundle]];
    
    // show the view...
    [self showView:view];
}


-(void)openNavigator
{
    //find the preexisting view...
    SBViewController *view = [self getController:[SBNavigatorView class]];
    if (view == nil)
        view = [[SBNavigatorView alloc] initWithNibName:@"SBNavigatorView" bundle:[NSBundle mainBundle]];
    
    // show the view...
    [self showView:view];    
}
 

-(void)openConfiguration
{
    // find a preexisting view...
    SBViewController *view = [self getController:[SBConfigureView class]];
    if (view == nil)
        view = [[SBConfigureView alloc] initWithNibName:@"SBConfigureView" bundle:[NSBundle mainBundle]];
    
    // show the view...
    [self showView:view];
}


-(void)openBookmarkSingleton:(int)theOrdinal
{
	// find a preexisting view...
	SBViewController *view = [self getController:[SBConfigureSingletonView class]];
	if (view == nil)
		view = [[SBConfigureSingletonView alloc] initWithNibName:@"SBConfigureSingletonView" bundle:[NSBundle mainBundle]];
	
	// set...
	[((SBConfigureSingletonView *)view) setOrdinal:theOrdinal];
	
	// show the view...
	[self showView:view];
}



- (void)dealloc
{
    [window release];
    //[viewController release];
    [controllers release];
    [super dealloc];
}

@end
